/*  Copyright 2009 Marc Toussaint
    email: mtoussai@cs.tu-berlin.de

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a COPYING file of the GNU General Public License
    along with this program. If not, see <http://www.gnu.org/licenses/> */

#ifndef MT_ors_swift_h
#define MT_ors_swift_h

#include "array.h"
namespace ors{ struct Graph; struct Body; }
class SWIFT_Scene;

//contains all information necessary to communicate with swift
struct SwiftModule{
  SWIFT_Scene *scene;
  intA ids;
  double cutoff;
  SwiftModule(){ scene=NULL; cutoff=.1; }
  ~SwiftModule();
  
  void init(const ors::Graph& C,double _cutoff=.1);
  void deactivate(const MT::Array<ors::Body*>& bodies);
  void computeProxies(ors::Graph& C,bool dumpReport=false);
};



#ifdef MT_IMPLEMENTATION
#  include "ors_swift.cpp"
#endif
#endif
